<?php

/*
=====================================================
 ExpressionEngine - by pMachine
-----------------------------------------------------
 http://www.pmachine.com/
-----------------------------------------------------
 Copyright (c) 2003 pMachine, Inc.
=====================================================
 THIS IS COPYRIGHTED SOFTWARE
 PLEASE READ THE LICENSE AGREEMENT
 http://www.pmachine.com/license/
=====================================================
 File: pi.auto_linker.php
-----------------------------------------------------
 Purpose: URL/Email encoding plugin
=====================================================

*/


$plugin_info = array(
						'pi_name'			=> 'URL and Email Auto-linker',
						'pi_version'		=> '1.0',
						'pi_author'			=> 'Rick Ellis',
						'pi_author_url'		=> 'http://www.pmachine.com/',
						'pi_description'	=> 'Automatically links URLs within text',
						'pi_usage'			=> Auto_linker::usage()
					);


class Auto_linker {

    var $return_data;


    function Auto_linker($str = '')
    {
        global $TMPL, $FNS, $PREFS;

        if ($str == '')
        	$str = $TMPL->tagdata;
                
    		$pop = ($TMPL->fetch_param('target') == 'blank') ? " target=\"_blank\" " : "";
    
        // Clear period from the end of URLs
        $str = preg_replace("#(^|\s|\()((http://|https://|www\.)\w+[^\s\)]+)\.([\s\)])#i", "\\1\\2{{PERIOD}}\\4", $str);
        
        // Auto link URL
        $str = preg_replace("#(^|\s|\()((http(s?)://)|(www\.))(\w+[^\s\)\<]+)#i", "\\1<a href=\"http\\4://\\5\\6\"$pop>http\\4://\\5\\6</a>", $str);
        
        // Clean up periods
        $str = preg_replace("#<a href=(.+?){{PERIOD}}(.+?){{PERIOD}}</a>#", "<a href=\\1\\2</a>.", $str);
        
        // Clear period from the end of emails
        $str = preg_replace("#(^|\s|\()([a-zA-Z0-9_\.\-]+)@([a-zA-Z0-9\-]+)\.([a-zA-Z0-9\-\.]*)\.([\s\)])#i","\\1\\2@\\3.\\4\\5{{PERIOD}}",$str);
        
        // Auto link email
        $str = preg_replace("/(^|\s|\()([a-zA-Z0-9_\.\-]+)@([a-zA-Z0-9\-]+)\.([a-zA-Z0-9\-\.]*)/i", "\\1<a href=\"mailto:\\2@\\3.\\4\">\\2@\\3.\\4</a>", $str);

		// Cleand up stray periods
 		$str = str_replace(" {{PERIOD}}", ". ", $str);
 
 		$this->return_data = $str;
    }
    // END
    
// ----------------------------------------
//  Plugin Usage
// ----------------------------------------

// This function describes how the plugin is used.
//  Make sure and use output buffering

function usage()
{
ob_start(); 
?>
Auto-links URLs

Wrap whatever you want formatted within:

{exp:auto_linker}

text you want processed

{/exp:auto_linker}


There is one optional parameter which will option links in a new window.

target="blank"



<?php
$buffer = ob_get_contents();
	
ob_end_clean(); 

return $buffer;
}
// END


}
// END CLASS
?>